<template>
  <NetworkGraphVis
    id="network-graph"
    v-bind:network_data_json="network_data_json"
    v-bind:selected_algorithm="selected_algorithm"
    v-bind:loaded="loadedNetwork"
    @node_selected="updateSelectedText($event)"
    @nodes_unselected="clearSelectedText($event)"
  />
  <div v-if="display_result">
    <div class="row">
      <InfoBox
        v-bind:text="optTreshold"
        v-bind:title="title_treshold"
        v-bind:loaded="loaded_result_network"
        v-bind:show_tooltip="true"
        v-bind:tooltip_text="tooltipTextTreshold"
      >
      </InfoBox>
    </div>
    <div class="row">
      <InfoBox
        v-bind:text="truePositives"
        v-bind:title="titleTruePositives"
        v-bind:loaded="loaded_result_network"
        v-bind:show_tooltip="true"
        v-bind:tooltip_text="tooltipTextTruePositives"
        class="component_flex_start"
      >
      </InfoBox>
      <InfoBox
        v-bind:text="falsePositives"
        v-bind:title="titleFalsePositives"
        v-bind:loaded="loaded_result_network"
        v-bind:show_tooltip="true"
        v-bind:tooltip_text="tooltipTextFalsePositives"
      >
      </InfoBox>
      <InfoBox
        v-bind:text="trueNegatives"
        v-bind:title="titleTrueNegatives"
        v-bind:loaded="loaded_result_network"
        v-bind:show_tooltip="true"
        v-bind:tooltip_text="tooltipTextTrueNegatives"
        class="component_flex_end"
      >
      </InfoBox>
      <InfoBox
        v-bind:text="falseNegatives"
        v-bind:title="titleFalseNegatives"
        v-bind:loaded="loaded_result_network"
        v-bind:show_tooltip="true"
        v-bind:tooltip_text="tooltipTextFalseNegatives"
        class="component_flex_end"
      >
      </InfoBox>
    </div>
  </div>
  <div v-else>
    <div class="row" v-if="display_all_network_informations">
      <InfoBox
        v-bind:text="textBackgoundInformation"
        v-bind:title="titleBackgoundInformation"
        v-bind:loaded="loaded_original_network"
        v-bind:show_tooltip="false"
      >
      </InfoBox>
    </div>
    <div class="row">
      <InfoBox
        v-bind:text="textNodes"
        v-bind:title="title_nodes"
        v-bind:loaded="loaded_original_network"
        v-bind:show_tooltip="false"
      >
      </InfoBox>
      <InfoBox
        v-bind:text="textEdges"
        v-bind:title="title_edges"
        v-bind:loaded="loaded_original_network"
        v-bind:show_tooltip="false"
      >
      </InfoBox>
      <InfoBox v-if="display_all_network_informations"
        v-bind:text="textDensity"
        v-bind:title="title_density"
        v-bind:loaded="loaded_original_network"
        v-bind:show_tooltip="true"
        v-bind:tooltip_text="tooltipTextDensity"
      >
      </InfoBox>
      <InfoBox v-if="display_all_network_informations"
        v-bind:text="textAvgDegreeCentrality"
        v-bind:title="titleAvgDegreeCentrality"
        v-bind:loaded="loaded_original_network"
        v-bind:show_tooltip="true"
        v-bind:tooltip_text="tooltipTextAvgDegreeCentrality"
      >
      </InfoBox>
      <InfoBox v-if="display_all_network_informations"
        v-bind:text="avg_effective_size"
        v-bind:title="titleAvgEffectiveSize"
        v-bind:loaded="loaded_avg_effective_size"
        v-bind:show_tooltip="true"
        v-bind:tooltip_text="tooltipTextAvgEffectiveSize"
      >
      </InfoBox>
      <InfoBox v-if="display_all_network_informations"
        v-bind:text="degree_centralization"
        v-bind:title="titleDegreeCentralization"
        v-bind:loaded="loaded_degree_centralization"
        v-bind:show_tooltip="true"
        v-bind:tooltip_text="tooltipTextDegreeCentralization"
      >
      </InfoBox>
      <InfoBox v-if="display_all_network_informations"
        v-bind:text="betweenness_centralization"
        v-bind:title="titleBetweennessCentralization"
        v-bind:loaded="loaded_betweenness_cantralization"
        v-bind:show_tooltip="true"
        v-bind:tooltip_text="tooltipTextBetweennessCentralization"
      >
      </InfoBox>
    </div>
    <div class="row">
      <InfoBox
        v-if="showAdditionalInfos"
        id="info-selected"
        v-bind:text="textSelected"
        v-bind:loaded="true"
        v-bind:show_tooltip="false"
      >
      </InfoBox>
    </div>
  </div>
</template>

<script>
import InfoBox from "./basic/InfoBox.vue";
import NetworkGraphVis from "./basic/NetworkGraphVis.vue";

export default {
  name: "Graph",
  components: {
    NetworkGraphVis,
    InfoBox,
  },
  props: {
    network_data_json: JSON,
    display_result: Boolean,
    display_all_network_informations: Boolean,
    selected_algorithm: String,
    loaded_original_network: Boolean,
    loaded_result_network: Boolean,
    loaded_betweenness_cantralization: Boolean,
    loaded_degree_centralization: Boolean,
    loaded_avg_effective_size: Boolean,
    betweenness_centralization: Number,
    degree_centralization: Number,
    avg_effective_size: Number,
  },
  computed: {
    optTreshold: function () {
      if (this.network_data_json != null) {
        return this.network_data_json.evaluation.opt_treshold;
      }
      return 0;
    },
    truePositives: function () {
      if (this.network_data_json != null) {
        return this.network_data_json["prediction_result"]["TP"];
      }
      return -1;
    },
    trueNegatives: function () {
      if (this.network_data_json != null) {
        return this.network_data_json["prediction_result"]["TN"];
      }
      return -1;
    },
    falsePositives: function () {
      if (this.network_data_json != null) {
        return this.network_data_json["prediction_result"]["FP"];
      }
      return -1;
    },
    falseNegatives: function () {
      if (this.network_data_json != null) {
        return this.network_data_json["prediction_result"]["FN"];
      }
      return -1;
    },
    titleTruePositives: function () {
      return "<font color='#71c02f'>True Positives (TP)</font> ";
    },
    titleFalsePositives: function () {
      return "<font color='#da105a'>False Positives (FP)</font> ";
    },
    titleTrueNegatives: function () {
      return "True Negatives (TN)";
    },
    titleFalseNegatives: function () {
      return "<font color='#fbb11e'>False Negatives (FN)</font> ";
    },
    loadedNetwork: function () {
      if (this.network_data_json == null) {
        return false;
      }
      return true;
    },
  },
  data: function () {
    return {
      textBackgoundInformation: "",
      textNodes: "",
      textEdges: "",
      textSelected: "",
      textDensity: "",
      textAvgDegreeCentrality: "",
      textAvgEffectiveSize: "",
      textDegreeCentralization: "",

      titleBackgoundInformation: "Informationen zum Netzwerk",
      title_nodes: "Knoten",
      title_edges: "Kanten",
      title_treshold: "Threshold",
      title_density: "Dichte",
      titleAvgDegreeCentrality: "Average Degree Centrality",
      titleAvgEffectiveSize: "Average Effective Size",
      titleDegreeCentralization: "Degree Centralization",
      titleBetweennessCentralization: "Betweenness Centralization",

      tooltipTextDensity:
        "Wie viele Kanten das aktuelle Netwerk hat im Vergleich zu allen Kanten, die es haben könnte.",
      tooltipTextAvgDegreeCentrality:
        "Anzahl der Nachbarn, die ein Knoten im Durchschnitt hat.",
      tooltipTextAvgEffectiveSize:
        "Die Effective Size misst die Anzahl der nicht-redundanten Beziehungen eines Knotens. Die Average Effective Size verallgemeinert die Effective Size auf das gesamte Netzwerk und kann einen Wert zwischen 0 (niedrigster) und 1 (höchster) einnehmen.",
      tooltipTextDegreeCentralization:
        "Die Degree Centrality misst die Anzahl der Nachbarn eines Knotens. Die Degree Centralization verallgemeinert die Degree Centrality auf das gesamte Netzwerk und kann einen Wert zwischen 0 (niedrigster) und 1 (höchster) einnehmen.",
      tooltipTextBetweennessCentralization:
        "Die Betweenness Centrality misst die Wichtigkeit einzelner Knoten im Informationsfluss des Netzwerks. Die Betweenness Centralization verallgemeinert die Betweenness Centrality auf das gesamte Netzwerk und kann einen Wert zwischen 0 (niedrigster) und 1 (höchster) einnehmen.",
      tooltipTextTreshold:
        "Das oben dargestellte Netzwerk ist jenes, das entsteht, wenn der Threshold, der hier angegeben ist, verwendet wird.",
      tooltipTextTruePositives: "Anzahl korrekt vorhergesagter Kanten",
      tooltipTextTrueNegatives:
        "Anzahl Kanten, die korrekterweise nicht vorhergesagt wurden",
      tooltipTextFalsePositives:
        "Anzahl Kanten, die fälschlicherweise vorhergesagt wurden (jedoch tatsächlich nicht existieren)",
      tooltipTextFalseNegatives:
        "Anzahl Kanten, die fälschlicherweise nicht vorhergesagt wurden (jedoch tatsächlich existieren)",
      showAdditionalInfos: false,
      loaded_result: false,
    };
  },
  mounted: function () {
    if (this.network_data_json != null) {
      this.textBackgoundInformation =
        this.network_data_json.info.background_information;
      this.textNodes = this.network_data_json.info.nodes_count;
      this.textEdges = this.network_data_json.info.edges_count;
      this.textDensity = this.network_data_json.info.density;
      this.textAvgDegreeCentrality =
        this.network_data_json.info.avg_degree_centrality;
      this.textAvgEffectiveSize =
        this.network_data_json.info.avg_effective_size;
      this.textDegreeCentralization =
        this.network_data_json.info.degree_centralization;
    }
  },
  watch: {
    network_data_json: function () {
      if (this.network_data_json != null) {
        this.textBackgoundInformation =
          this.network_data_json.info.background_information;
        this.textNodes = this.network_data_json.info.nodes_count;
        this.textEdges = this.network_data_json.info.edges_count;
        this.textDensity = this.network_data_json.info.density;
        this.textAvgDegreeCentrality =
          this.network_data_json.info.avg_degree_centrality;
        this.textAvgEffectiveSize =
          this.network_data_json.info.avg_effective_size;
        this.textDegreeCentralization =
          this.network_data_json.info.degree_centralization;
      }
    },
  },
  methods: {
    updateSelectedText(newText) {
      this.showAdditionalInfos = true;
      this.textSelected += newText;
    },
    clearSelectedText() {
      this.textSelected = "";
      this.showAdditionalInfos = false;
    },
  },
};
</script>

<style scoped>
.row {
  display: flex;
  flex-direction: row;
  flex: 1 1 0px;
  flex-wrap: wrap;
  justify-content: space-between;
  margin-top: 10px;
  margin-bottom: 10px;
}

#network-graph {
  margin: 5px;
}

#info-selected {
  overflow: auto;
  max-width: 50vw;
}
</style>